<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppClassTypeAndEnum xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassTypeAndEnum.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2014 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.utils.CppGenUtils;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppEnumerations;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppInnerClassifiers;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppPrimitiveTypes;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.NoCodeGen;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DataType;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLFactory;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.VisibilityKind;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * @author Önder GÜRCAN (onder.gurcan@cea.fr)</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassTypeAndEnum.html">CppClassTypeAndEnum</a> {
<a class="jxr_linenumber" name="L37" href="#L37">37</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Object <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassTypeAndEnum.html">CppClassTypeAndEnum</a>(<strong class="jxr_keyword">final</strong> Classifier clazz) {
<a class="jxr_linenumber" name="L38" href="#L38">38</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L39" href="#L39">39</a>      CharSequence _TypesAndEnumsForVisibility = CppClassTypeAndEnum.TypesAndEnumsForVisibility(clazz, VisibilityKind.PUBLIC_LITERAL);
<a class="jxr_linenumber" name="L40" href="#L40">40</a>      String publicStr = _TypesAndEnumsForVisibility.toString();
<a class="jxr_linenumber" name="L41" href="#L41">41</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L42" href="#L42">42</a>      String _section = CppGenUtils.getSection(VisibilityKind.PUBLIC_LITERAL, publicStr);
<a class="jxr_linenumber" name="L43" href="#L43">43</a>      _builder.append(_section, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L45" href="#L45">45</a>      CharSequence _TypesAndEnumsForVisibility_1 = CppClassTypeAndEnum.TypesAndEnumsForVisibility(clazz, VisibilityKind.PROTECTED_LITERAL);
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      String protectedStr = _TypesAndEnumsForVisibility_1.toString();
<a class="jxr_linenumber" name="L47" href="#L47">47</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L48" href="#L48">48</a>      String _section_1 = CppGenUtils.getSection(VisibilityKind.PROTECTED_LITERAL, protectedStr);
<a class="jxr_linenumber" name="L49" href="#L49">49</a>      _builder.append(_section_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L50" href="#L50">50</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      CharSequence _TypesAndEnumsForVisibility_2 = CppClassTypeAndEnum.TypesAndEnumsForVisibility(clazz, VisibilityKind.PRIVATE_LITERAL);
<a class="jxr_linenumber" name="L52" href="#L52">52</a>      String privateStr = _TypesAndEnumsForVisibility_2.toString();
<a class="jxr_linenumber" name="L53" href="#L53">53</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      String _section_2 = CppGenUtils.getSection(VisibilityKind.PRIVATE_LITERAL, privateStr);
<a class="jxr_linenumber" name="L55" href="#L55">55</a>      _builder.append(_section_2, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L57" href="#L57">57</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>    }
<a class="jxr_linenumber" name="L59" href="#L59">59</a>    
<a class="jxr_linenumber" name="L60" href="#L60">60</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence CppClassTypeAndEnumPackage(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Package pkg) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>      CharSequence _xblockexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>      {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>        VisibilityKind _get = VisibilityKind.get(VisibilityKind.PACKAGE);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>        CppClassTypeAndEnum.TypesAndEnumsForVisibility(pkg, _get);
<a class="jxr_linenumber" name="L65" href="#L65">65</a>        VisibilityKind _get_1 = VisibilityKind.get(VisibilityKind.PUBLIC);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>        _xblockexpression = CppClassTypeAndEnum.TypesAndEnumsForVisibility(pkg, _get_1);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>      }
<a class="jxr_linenumber" name="L68" href="#L68">68</a>      <strong class="jxr_keyword">return</strong> _xblockexpression;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>    }
<a class="jxr_linenumber" name="L70" href="#L70">70</a>    
<a class="jxr_linenumber" name="L71" href="#L71">71</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence TypesAndEnumsForVisibility(<strong class="jxr_keyword">final</strong> Namespace ne, <strong class="jxr_keyword">final</strong> VisibilityKind visibilityFilter) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L73" href="#L73">73</a>      {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>        EList&lt;Element&gt; _ownedElements = ne.getOwnedElements();
<a class="jxr_linenumber" name="L75" href="#L75">75</a>        <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Element ownedElement : _ownedElements) {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>          CharSequence _TypeAndEnumForVisibility = CppClassTypeAndEnum.TypeAndEnumForVisibility(ownedElement, visibilityFilter);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>          _builder.append(_TypeAndEnumForVisibility, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>        }
<a class="jxr_linenumber" name="L80" href="#L80">80</a>      }
<a class="jxr_linenumber" name="L81" href="#L81">81</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>    }
<a class="jxr_linenumber" name="L83" href="#L83">83</a>    
<a class="jxr_linenumber" name="L84" href="#L84">84</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence TypeAndEnumForVisibility(<strong class="jxr_keyword">final</strong> Element element, <strong class="jxr_keyword">final</strong> VisibilityKind visibilityFilter) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>      <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L86" href="#L86">86</a>      <strong class="jxr_keyword">boolean</strong> _hasStereotype = GenUtils.hasStereotype(element, NoCodeGen.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>      <strong class="jxr_keyword">boolean</strong> _not = (!_hasStereotype);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>      <strong class="jxr_keyword">if</strong> (!_not) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>        _and = false;
<a class="jxr_linenumber" name="L90" href="#L90">90</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L91" href="#L91">91</a>        _and = (element instanceof Classifier);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>      }
<a class="jxr_linenumber" name="L93" href="#L93">93</a>      <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>        VisibilityKind elementVisibility = ((Classifier) element).getVisibility();
<a class="jxr_linenumber" name="L95" href="#L95">95</a>        <strong class="jxr_keyword">int</strong> value = elementVisibility.getValue();
<a class="jxr_linenumber" name="L96" href="#L96">96</a>        <strong class="jxr_keyword">int</strong> _value = visibilityFilter.getValue();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>        <strong class="jxr_keyword">boolean</strong> _equals = (value == _value);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>        <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>          <strong class="jxr_keyword">if</strong> ((element instanceof Enumeration)) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a>           <strong class="jxr_keyword">return</strong> CppEnumerations.CppEnumerationDefinition(((Enumeration) element));
<a class="jxr_linenumber" name="L101" href="#L101">101</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L102" href="#L102">102</a>           <strong class="jxr_keyword">if</strong> ((element instanceof PrimitiveType)) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a>             <strong class="jxr_keyword">return</strong> CppPrimitiveTypes.CppPrimitiveTypeDefinition(((PrimitiveType) element));
<a class="jxr_linenumber" name="L104" href="#L104">104</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L105" href="#L105">105</a>             <strong class="jxr_keyword">boolean</strong> _and_1 = false;
<a class="jxr_linenumber" name="L106" href="#L106">106</a>             <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L107" href="#L107">107</a>             <strong class="jxr_keyword">if</strong> ((element instanceof DataType)) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a>               _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L109" href="#L109">109</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L110" href="#L110">110</a>               EClass _eClass = element.eClass();
<a class="jxr_linenumber" name="L111" href="#L111">111</a>               UMLPackage _uMLPackage = UMLFactory.eINSTANCE.getUMLPackage();
<a class="jxr_linenumber" name="L112" href="#L112">112</a>               EClass _<strong class="jxr_keyword">class</strong>_ = _uMLPackage.getClass_();
<a class="jxr_linenumber" name="L113" href="#L113">113</a>               <strong class="jxr_keyword">boolean</strong> _equals_1 = _eClass.equals(_<strong class="jxr_keyword">class</strong>_);
<a class="jxr_linenumber" name="L114" href="#L114">114</a>               _or = _equals_1;
<a class="jxr_linenumber" name="L115" href="#L115">115</a>             }
<a class="jxr_linenumber" name="L116" href="#L116">116</a>             <strong class="jxr_keyword">if</strong> (!_or) {
<a class="jxr_linenumber" name="L117" href="#L117">117</a>               _and_1 = false;
<a class="jxr_linenumber" name="L118" href="#L118">118</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L119" href="#L119">119</a>               Element _owner = element.getOwner();
<a class="jxr_linenumber" name="L120" href="#L120">120</a>               <strong class="jxr_keyword">boolean</strong> _not_1 = (!(_owner instanceof org.eclipse.uml2.uml.Package));
<a class="jxr_linenumber" name="L121" href="#L121">121</a>               _and_1 = _not_1;
<a class="jxr_linenumber" name="L122" href="#L122">122</a>             }
<a class="jxr_linenumber" name="L123" href="#L123">123</a>             <strong class="jxr_keyword">if</strong> (_and_1) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a>               <strong class="jxr_keyword">boolean</strong> _isTemplateBoundElement = GenUtils.isTemplateBoundElement(((Classifier) element));
<a class="jxr_linenumber" name="L125" href="#L125">125</a>               <strong class="jxr_keyword">if</strong> (_isTemplateBoundElement) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a>                 <strong class="jxr_keyword">return</strong> CppInnerClassifiers.CppInnerBindDefinition(((Classifier) element));
<a class="jxr_linenumber" name="L127" href="#L127">127</a>               } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L128" href="#L128">128</a>                 <strong class="jxr_keyword">final</strong> VisibilityKind currentVisibility = CppGenUtils.getCurrentVisibility();
<a class="jxr_linenumber" name="L129" href="#L129">129</a>                 CppGenUtils.resetVisibility(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L130" href="#L130">130</a>                 <strong class="jxr_keyword">final</strong> CharSequence definition = CppInnerClassifiers.CppInnerClassDefinition(((Classifier) element));
<a class="jxr_linenumber" name="L131" href="#L131">131</a>                 CppGenUtils.resetVisibility(currentVisibility);
<a class="jxr_linenumber" name="L132" href="#L132">132</a>                 <strong class="jxr_keyword">return</strong> definition;
<a class="jxr_linenumber" name="L133" href="#L133">133</a>               }
<a class="jxr_linenumber" name="L134" href="#L134">134</a>             }
<a class="jxr_linenumber" name="L135" href="#L135">135</a>           }
<a class="jxr_linenumber" name="L136" href="#L136">136</a>         }
<a class="jxr_linenumber" name="L137" href="#L137">137</a>       }
<a class="jxr_linenumber" name="L138" href="#L138">138</a>     }
<a class="jxr_linenumber" name="L139" href="#L139">139</a>     <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L140" href="#L140">140</a>   }
<a class="jxr_linenumber" name="L141" href="#L141">141</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
